/* 
 * Stack abstract data type - Last In First Out.
 * Copyright (C) 2003 MiKael NAVARRO
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

/*
 * Definition of the Stack struct.,
 * and public interface.
 */

#ifndef _STACK_H
#define _STACK_H

/* Abstract data type */
typedef struct Stack *Stack;


/*
 * Constructor.
 */
Stack stack_new(void);

/*
 * Destructor.
 */
int stack_destroy(Stack stack);


/*
 * Push n.
 * With memory reallocation if necessary.
 */
int stack_push(Stack stack, double n);

/*
 * Pop.
 * Test if stack is empty?
 */
double stack_pop(Stack stack);


/*
 * Top.
 * Test if stack is empty?
 */
double stack_top(Stack stack);

/*
 * Head idx.
 */
int stack_top_index(Stack stack);


/*
 * Stack is full? 0|1
 */
int stack_is_full(Stack stack);

/*
 * Stack is empty? 0|1
 */
int stack_is_empty(Stack stack);


/*
 * Get elem (pos=i). 
 */
double stack_elem(Stack stack, int i);


/*
 * Display stack.
 * Display only the first DEPTH elems.
 */
int stack_aff(Stack stack);


#endif /* _STACK_H */
